/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2013 Oracle and/or its affiliates. All rights reserved.
 *
 * The contents of this file are subject to the terms of the GNU General
 * Public License Version 2 only ("GPL"). You may not use this file except
 * in compliance with the License.  You can obtain a copy of the License at
 * https://avatar.java.net/license.html or legal/LICENSE.txt.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at legal/LICENSE.txt.
 *
 * GPL Classpath Exception:
 * Oracle designates this particular file as subject to the "Classpath"
 * exception as provided by Oracle in the GPL Version 2 section of the License
 * file that accompanied this code.
 *
 * Modifications:
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyright [year] [name of copyright owner]"
 *
 */

var avatar = require("org/glassfish/avatar");

var itemsProvider = new avatar.FileDataProvider({filename: "rest-sample.txt", key: "key"});

/*
 * var itemsProvider = new avatar.JPADataProvider(
 *       {persistenceUnit:"rest",
 *        createTables:"true",
 *        entityType:"Item"}
 *    );
 */

avatar.registerRestService({url: "data/items/"}, 
    function() {
        this.onGet = function(request, response) {
            return itemsProvider.getCollection()
            .then(function(result){
                var items = { "items" : result.data };
                return response.send(items);
            });
        };
    }
);

avatar.registerRestService({url:"data/items/{item}"}, 
    function() {
        this.onGet = function(request, response) {
            itemsProvider.get(this.item, function(error, itemValue){
                if (!itemValue) {
                    itemValue = {};
                }
                response.send(itemValue).done();
            });
        };

        this.onPut = function(request, response) {
            return itemsProvider.put(this.item, request.data)
            .then(function(result){
                return response.send(result);
            });
        };

        this.onDelete = function(request, response) {
            return itemsProvider.del(this.item)
            .then(function(result){
                return response.send(result);
            });
        };
    }
);
